﻿' לצורך העבודה עם MySQL, יש להוסיף את ה-Reference: MySql.Data.dll מתיקיית ה MySql שב-ProgramFiles
' תיקייה זו נוצרת בהתקנת הקונקטור: https://dev.mysql.com/downloads/connector/net/

Imports System.Threading
Imports MySql.Data.MySqlClient

Public Class frmMain

    Dim dataAdapter As MySqlDataAdapter  ' עבודה עם הנתונים
    Dim result As DataSet                ' טבלה עבור הכנסת תוצאת השאילתא

    Private Sub CBoxes_SaveItems(sender As ComboBox, e As KeyEventArgs) Handles cbbxAddress.KeyDown, cbbxUser.KeyDown, cbbxManual.KeyDown
        ' מטרת שגרה זו, ללכוד הקשת אנטר בתיבות קומבו בוקס, להוסיף את הטקסט שבתיבה לרשימה הנפתחת ולהעביר לשלב הבא
        If e.KeyCode <> Keys.Enter OrElse sender.Text = "" Then Exit Sub

        Dim current As String = sender.Text                                     ' הצבת הטקסט המבוקש במשתנה
        If sender.Items.Contains(current) Then sender.Items.Remove(current)     ' מחיקת הטקסט המבוקש ממיקום ישן ברשימה, במידה וקיים
        sender.Items.Insert(0, current)                                         ' הוספת הטקסט המבוקש לראש הרשימה הנפתחת
        sender.SelectedIndex = 0                                                ' בחירה באופצייה שבראש הרשימה  (בכדי להחזיר את הטקסט לתיבה במידה והוא נמחק)

        ' במידה והקובמובוקס הוא שאילתא - בצע אותה. אחרת, העבר פוקוס לתיבה הבאה
        If sender.Name = "cbbxManual" Then btnManual_Click(sender, Nothing) Else SelectNextControl(sender, True, True, True, True)

    End Sub

    Private Sub LstBoxes_KeyDown(sender As Object, e As KeyEventArgs) Handles txtPass.KeyDown, lstDB.KeyDown, lstTables.KeyDown
        ' תפקיד שגרה זו ללכוד הקשה על אנטר בתוך תיבת טקסט ולשלוח לטיפול המתאים
        If e.KeyCode <> Keys.Enter Then Exit Sub

        If sender Is txtPass Then
            SelectNextControl(sender, True, True, True, True)       ' במידה והוקש אנטר בתיבת הסיסמה, עבור לתיבה הבאה
        ElseIf sender Is lstDB Then
            lstDB_DoubleClick(sender, Nothing)                      ' במידה והוקש אנטר בתיבת המסדים, טען טבלאות
        ElseIf sender Is lstTables Then
            lstTables_DoubleClick(sender, Nothing)                  ' במידה והוקש אנטר בתיבת טבלאות, טען טבלה נבחרת
        End If

    End Sub

    Private Async Sub BtnLoadDB_Click(sender As Object, e As EventArgs) Handles btnLoadDB.Click

        ' מכין את טקסט החיבור לשרת
        Dim connString = BeforeQuery()
        If connString = "" Then Exit Sub

        ' איפוס רשימות המסדים והטבלאות מתוצאות קודמות
        lstDB.DataSource = Nothing
        lstTables.DataSource = Nothing

        ' ביצוע השאילתא המבקשת את רשימת המסדים, וכיבוי מחוון הטעינה
        Dim success As Boolean = Await Task.Run(Function() query(connString, "SHOW DATABASES;"))
        If AfterQuery(success, "לא קיימים מסדי נתונים!", lstDB, "Database") = False Then Exit Sub

    End Sub

    Private Async Sub LstDB_DoubleClick(sender As Object, e As EventArgs) Handles lstDB.DoubleClick

        ' מכין את טקסט החיבור לשרת
        Dim connString = BeforeQuery()
        If connString = "" Then Exit Sub

        ' מתריע במידה ולא נבחר מסד נתונים.
        If lstDB.SelectedIndex = -1 Then If MsgBox("לא נבחר מסד נתונים!", תקלה) Then Exit Sub

        ' ביצוע השאילתא המבקשת את רשימת הטבלאות, וכיבוי מחוון הטעינה
        Dim success As Boolean = Await Task.Run(Function() query(connString, "SHOW TABLES;"))
        If AfterQuery(success, "לא קיימות טבלאות במסד זה.", lstTables, "Tables_in_" & lstDB.SelectedValue.ToString) = False Then Exit Sub

    End Sub

    Private Sub lstTables_DoubleClick(sender As Object, e As EventArgs) Handles lstTables.DoubleClick
        If lstDB.SelectedIndex = -1 Or lstTables.SelectedIndex = -1 Or checkChanges() = False Then Exit Sub

        ' הכנת השאילתא לקריאת הטבלה, ו"לחיצה" על כפתור "בצע שאילתא"
        cbbxManual.Text = "SELECT * FROM " & lstTables.SelectedValue.ToString & ";"
        BtnManual_Click(sender, e)

    End Sub

    Private Async Sub BtnManual_Click(sender As Object, e As EventArgs) Handles btnManual.Click

        ' מכין את טקסט החיבור לשרת
        Dim connString = BeforeQuery()
        If connString = "" Then Exit Sub

        ' מכין את טקסט השאילתא
        If cbbxManual.Text = "" Then If MsgBox("לא הוקלדה שאילתא לביצוע!", תקלה) Then Exit Sub
        Dim queryString = cbbxManual.Text

        ' ביצוע השאילתא, וכיבוי מחוון הטעינה
        Dim success As Boolean = Await Task.Run(Function() query(connString, queryString))
        If AfterQuery(success, "לא קיימים נתונים בטבלה זו.", tblMain, "") = False Then Exit Sub

    End Sub

    Private Sub CellChange(sender As Object, e As EventArgs) Handles tblMain.CellEndEdit

        ' לגבי עדכון אוטומטי בגמר שינוי כל תא ראה כאן: https://stackoverflow.com/questions/12546327/update-database-from-datagridview-on-event-does-not-work-properly
        ' tblMain.EndEdit()
        ' If updateDB() = False Then Exit Sub

    End Sub

    Private Sub BtnUpdate_Click(sender As Object, e As EventArgs) Handles btnUpdate.Click
        ' בדיקה אם בכלל יש נתונים בטבלה, ואם כן, האם בוצעו בה שינויים
        If tblMain.RowCount < 2 OrElse result.GetChanges Is Nothing Then If MsgBox("לא בוצע כל שינוי!", הודעה) Then Exit Sub

        tblMain.EndEdit()                                                    ' אישור על סיום ביצוע השינויים
        If UpdateDB(False) Then MsgBox("השינויים עודכנו בשרת!", הודעה)    ' ביצוע העדכון

    End Sub

    Private Sub חלון_ראשי_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If checkChanges() = False Then e.Cancel = True  ' במידה ויש שינויים, אל תסגור לפני ווידוא על שמירה
    End Sub


    Private Function BeforeQuery() As String

        If checkChanges() = False Then Return ""    ' במידה ויש שינויים שלא נשמרו - הצע שמירה

        ' ווידוא שמלאו שדות פרטי השרת
        For Each box In grpServer.Controls
            If TypeOf (box) IsNot Label AndAlso box.Text = "" Then If MsgBox("יש להזין ערך בשדה: " & vbCrLf & גרשיים & box.Tag & גרשיים, תקלה) Then Return ""
        Next

        ' ניקוי שאריות משאילתות קודמות
        result = Nothing
        lblSum.Text = "סה" & גרשיים & "כ: 0 שורות, 0 עמודות"
        tblMain.DataSource = Nothing

        ' הכנת טקסט החיבור למסד לפני / אחרי בחירת מסד הנתונים + קידוד לעברית
        Dim connString As String = "server=" & cbbxAddress.Text & ";" & "user id=" & cbbxUser.Text & ";" & "password=" & txtPass.Text
        If lstDB.SelectedIndex <> -1 Then connString = connString & ";" & "database=" & lstDB.SelectedValue.ToString
        connString = connString & ";" & "Character Set=utf8"

        pbarLoad.Visible = True

        Return connString
        Return True
    End Function

    Private Function query(connString As String, queryString As String) As Boolean

        ' הכנת ה"תשתית" לשאילתא וקישורה למאגר
        Dim conn As New MySqlConnection    ' בקשת החיבור למסד ופרטי החיבור
        conn.ConnectionString = connString ' מחרוזת פרטי הגישה למסד הנתונים
        Dim command As New MySqlCommand    ' השאילתא
        dataAdapter = New MySqlDataAdapter ' עבודה מול הנתונים
        result = New DataSet               ' טבלה להכנסת תוצאת השאילתא

        ' פתיחת הקישור למאגר וביצוע השאילתא
        Try
            conn.Open()

            command.Connection = conn
            command.CommandText = queryString

            dataAdapter.SelectCommand = command
            dataAdapter.Fill(result)

            Dim cb As New MySqlCommandBuilder(dataAdapter)      ' גורם למעקב אחרי השינויים בטבלת המקור לצורך עדכון

            conn.Close()

        Catch ex As Exception
            result = Nothing
            If MsgBox("התקלה הבאה אירעה בעת נסיון החיבור:" & vbCrLf & vbCrLf & ex.Message, תקלה) Then Return False
        End Try

        Return True
    End Function

    Private Function AfterQuery(success As Boolean, empty As String, received As Object, column As String) As Boolean

        pbarLoad.Visible = False                ' כיבוי מחוון הטעינה

        If success = False Then Return False    ' יציאה במידה והשאילתא החזירה כשלון
        If result Is Nothing OrElse result.Tables.Count = 0 OrElse result.Tables(0).Rows.Count = 0 Then If MsgBox(empty, הודעה) Then Return False

        ' טעינת תוצאות השאילתא באובייקט הגרפי המציג אותן
        received.DataSource = result.Tables(0)
        If TypeOf (received) IsNot DataGridView Then
            received.DisplayMember = column
            received.ValueMember = column
        Else
            lblSum.Text = "סה" & גרשיים & "כ: " & received.RowCount - 1 & " שורות, " & received.ColumnCount & " עמודות"
        End If

        received.Select()       ' העברת ה"פוקוס" לאובייקט שהתמלא בנתונים
        Return True
    End Function

    Private Function UpdateDB(afterMSG As Boolean) As Boolean
        ' עדכון המסד על פי השינויים בטבלה שבתוכנה
        If Not afterMSG Then If MsgBox("האם אתם בטוחים שברצונכם לשנות את הנתונים בשרת?", שאלה + MsgBoxStyle.OkCancel + MsgBoxStyle.DefaultButton2) <> MsgBoxResult.Ok Then Return False
        Try
            dataAdapter.Update(result)
        Catch ex As Exception
            If MsgBox("התקלה הבאה אירעה בעת נסיון העדכון:" & vbCrLf & vbCrLf & ex.Message, תקלה) Then Return False
        End Try

        Return True
    End Function

    Private Function checkChanges() As Boolean

        ' במידה ובוצעו שינויים בטבלה, הצע לשמור אותם, ואפשר להתחרט מהבקשה לצאת מהטבלה
        If result IsNot Nothing AndAlso result.GetChanges IsNot Nothing Then
            Dim save As MsgBoxResult = MsgBox("האם לעדכן בשרת את השינויים כפי שבוצעו בטבלה?", שאלה + MsgBoxStyle.YesNoCancel + MsgBoxStyle.DefaultButton3)
            If save = MsgBoxResult.Cancel Then Return False
            If save = MsgBoxResult.Yes Then If UpdateDB(True) = False Then Return False
        End If

        Return True
    End Function

End Class
